diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/test/tx-duration-test.cc ns-3.45/src/wifi/test/tx-duration-test.cc
--- ns-3.44/src/wifi/test/tx-duration-test.cc	2025-03-09 16:55:49.807372600 -0700
+++ ns-3.45/src/wifi/test/tx-duration-test.cc	2025-06-01 20:34:45.634702200 -0700
@@ -1380,53 +1408,604 @@
     retval = retval &&
              CheckMuTxDuration(
                  std::list<uint32_t>{1536, 1536},
-                 std::list<HeMuUserInfo>{{{HeRu::RU_242_TONE, 1, true}, 0, 1},
-                                         {{HeRu::RU_242_TONE, 2, true}, 0, 1}},
+                 std::list<HeMuUserInfo>{{HeRu::RuSpec{RuType::RU_242_TONE, 1, true}, 0, 1},
+                                         {HeRu::RuSpec{RuType::RU_242_TONE, 2, true}, 0, 1}},
                  MHz_u{40},
                  NanoSeconds(800),
                  WIFI_PREAMBLE_HE_MU,
                  NanoSeconds(
                      1493600)) // equivalent to HE_SU for 20 MHz with 2 extra HE-SIG-B (i.e. 8 us)
-             && CheckMuTxDuration(std::list<uint32_t>{1536, 1536},
-                                  std::list<HeMuUserInfo>{{{HeRu::RU_242_TONE, 1, true}, 1, 1},
-                                                          {{HeRu::RU_242_TONE, 2, true}, 0, 1}},
-                                  MHz_u{40},
-                                  NanoSeconds(800),
-                                  WIFI_PREAMBLE_HE_MU,
-                                  NanoSeconds(1493600)) // shouldn't change if first PSDU is shorter
-             && CheckMuTxDuration(std::list<uint32_t>{1536, 76},
-                                  std::list<HeMuUserInfo>{{{HeRu::RU_242_TONE, 1, true}, 0, 1},
-                                                          {{HeRu::RU_242_TONE, 2, true}, 0, 1}},
-                                  MHz_u{40},
-                                  NanoSeconds(800),
-                                  WIFI_PREAMBLE_HE_MU,
-                                  NanoSeconds(1493600));
+             && CheckMuTxDuration(
+                    std::list<uint32_t>{1536, 1536},
+                    std::list<HeMuUserInfo>{{HeRu::RuSpec{RuType::RU_242_TONE, 1, true}, 1, 1},
+                                            {HeRu::RuSpec{RuType::RU_242_TONE, 2, true}, 0, 1}},
+                    MHz_u{40},
+                    NanoSeconds(800),
+                    WIFI_PREAMBLE_HE_MU,
+                    NanoSeconds(1493600)) // shouldn't change if first PSDU is shorter
+             && CheckMuTxDuration(
+                    std::list<uint32_t>{1536, 76},
+                    std::list<HeMuUserInfo>{{HeRu::RuSpec{RuType::RU_242_TONE, 1, true}, 0, 1},
+                                            {HeRu::RuSpec{RuType::RU_242_TONE, 2, true}, 0, 1}},
+                    MHz_u{40},
+                    NanoSeconds(800),
+                    WIFI_PREAMBLE_HE_MU,
+                    NanoSeconds(1493600));
 
     NS_TEST_EXPECT_MSG_EQ(retval, true, "an 802.11ax MU duration failed");
 
-    // 802.11be MU durations
+    // 802.11be SU durations
     retval = retval &&
-             CheckMuTxDuration(std::list<uint32_t>{1536, 1536},
-                               std::list<HeMuUserInfo>{{{HeRu::RU_242_TONE, 1, true}, 0, 1},
-                                                       {{HeRu::RU_242_TONE, 2, true}, 0, 1}},
-                               MHz_u{40},
-                               NanoSeconds(800),
-                               WIFI_PREAMBLE_EHT_MU,
-                               NanoSeconds(1493600)) // equivalent to 802.11ax MU
-             && CheckMuTxDuration(std::list<uint32_t>{1536, 1536},
-                                  std::list<HeMuUserInfo>{{{HeRu::RU_242_TONE, 1, true}, 1, 1},
-                                                          {{HeRu::RU_242_TONE, 2, true}, 0, 1}},
-                                  MHz_u{40},
-                                  NanoSeconds(800),
-                                  WIFI_PREAMBLE_EHT_MU,
-                                  NanoSeconds(1493600)) // shouldn't change if first PSDU is shorter
-             && CheckMuTxDuration(std::list<uint32_t>{1536, 76},
-                                  std::list<HeMuUserInfo>{{{HeRu::RU_242_TONE, 1, true}, 0, 1},
-                                                          {{HeRu::RU_242_TONE, 2, true}, 0, 1}},
-                                  MHz_u{40},
-                                  NanoSeconds(800),
-                                  WIFI_PREAMBLE_EHT_MU,
-                                  NanoSeconds(1493600));
+             CheckTxDuration(1536,
+                             EhtPhy::GetEhtMcs0(),
+                             MHz_u{20},
+                             NanoSeconds(800),
+                             WIFI_PREAMBLE_EHT_MU,
+                             NanoSeconds(1493600)) &&
+             CheckTxDuration(76,
+                             EhtPhy::GetEhtMcs0(),
+                             MHz_u{20},
+                             NanoSeconds(800),
+                             WIFI_PREAMBLE_EHT_MU,
+                             NanoSeconds(133600)) &&
+             CheckTxDuration(14,
+                             EhtPhy::GetEhtMcs0(),
+                             MHz_u{20},
+                             NanoSeconds(800),
+                             WIFI_PREAMBLE_EHT_MU,
+                             NanoSeconds(79200)) &&
+             CheckTxDuration(1536,
+                             EhtPhy::GetEhtMcs0(),
+                             MHz_u{40},
+                             NanoSeconds(800),
+                             WIFI_PREAMBLE_EHT_MU,
+                             NanoSeconds(772800)) &&
+             CheckTxDuration(76,
+                             EhtPhy::GetEhtMcs0(),
+                             MHz_u{40},
+                             NanoSeconds(800),
+                             WIFI_PREAMBLE_EHT_MU,
+                             NanoSeconds(92800)) &&
+             CheckTxDuration(14,
+                             EhtPhy::GetEhtMcs0(),
+                             MHz_u{40},
+                             NanoSeconds(800),
+                             WIFI_PREAMBLE_EHT_MU,
+                             NanoSeconds(65600)) &&
+             CheckTxDuration(1536,
+                             EhtPhy::GetEhtMcs0(),
+                             MHz_u{80},
+                             NanoSeconds(800),
+                             WIFI_PREAMBLE_EHT_MU,
+                             NanoSeconds(409600)) &&
+             CheckTxDuration(76,
+                             EhtPhy::GetEhtMcs0(),
+                             MHz_u{80},
+                             NanoSeconds(800),
+                             WIFI_PREAMBLE_EHT_MU,
+                             NanoSeconds(83200)) &&
+             CheckTxDuration(14,
+                             EhtPhy::GetEhtMcs0(),
+                             MHz_u{80},
+                             NanoSeconds(800),
+                             WIFI_PREAMBLE_EHT_MU,
+                             NanoSeconds(69600)) &&
+             CheckTxDuration(1536,
+                             EhtPhy::GetEhtMcs0(),
+                             MHz_u{160},
+                             NanoSeconds(800),
+                             WIFI_PREAMBLE_EHT_MU,
+                             NanoSeconds(232800)) &&
+             CheckTxDuration(76,
+                             EhtPhy::GetEhtMcs0(),
+                             MHz_u{160},
+                             NanoSeconds(800),
+                             WIFI_PREAMBLE_EHT_MU,
+                             NanoSeconds(69600)) &&
+             CheckTxDuration(14,
+                             EhtPhy::GetEhtMcs0(),
+                             MHz_u{160},
+                             NanoSeconds(800),
+                             WIFI_PREAMBLE_EHT_MU,
+                             NanoSeconds(69600)) &&
+             CheckTxDuration(1536,
+                             EhtPhy::GetEhtMcs0(),
+                             MHz_u{320},
+                             NanoSeconds(800),
+                             WIFI_PREAMBLE_EHT_MU,
+                             NanoSeconds(159200)) &&
+             CheckTxDuration(76,
+                             EhtPhy::GetEhtMcs0(),
+                             MHz_u{320},
+                             NanoSeconds(800),
+                             WIFI_PREAMBLE_EHT_MU,
+                             NanoSeconds(77600)) &&
+             CheckTxDuration(14,
+                             EhtPhy::GetEhtMcs0(),
+                             MHz_u{320},
+                             NanoSeconds(800),
+                             WIFI_PREAMBLE_EHT_MU,
+                             NanoSeconds(77600)) &&
+             CheckTxDuration(1536,
+                             EhtPhy::GetEhtMcs0(),
+                             MHz_u{20},
+                             NanoSeconds(1600),
+                             WIFI_PREAMBLE_EHT_MU,
+                             NanoSeconds(1578400)) &&
+             CheckTxDuration(76,
+                             EhtPhy::GetEhtMcs0(),
+                             MHz_u{20},
+                             NanoSeconds(1600),
+                             WIFI_PREAMBLE_EHT_MU,
+                             NanoSeconds(138400)) &&
+             CheckTxDuration(14,
+                             EhtPhy::GetEhtMcs0(),
+                             MHz_u{20},
+                             NanoSeconds(1600),
+                             WIFI_PREAMBLE_EHT_MU,
+                             NanoSeconds(80800)) &&
+             CheckTxDuration(1536,
+                             EhtPhy::GetEhtMcs0(),
+                             MHz_u{40},
+                             NanoSeconds(1600),
+                             WIFI_PREAMBLE_EHT_MU,
+                             NanoSeconds(815200)) &&
+             CheckTxDuration(76,
+                             EhtPhy::GetEhtMcs0(),
+                             MHz_u{40},
+                             NanoSeconds(1600),
+                             WIFI_PREAMBLE_EHT_MU,
+                             NanoSeconds(95200)) &&
+             CheckTxDuration(14,
+                             EhtPhy::GetEhtMcs0(),
+                             MHz_u{40},
+                             NanoSeconds(1600),
+                             WIFI_PREAMBLE_EHT_MU,
+                             NanoSeconds(66400)) &&
+             CheckTxDuration(1536,
+                             EhtPhy::GetEhtMcs0(),
+                             MHz_u{80},
+                             NanoSeconds(1600),
+                             WIFI_PREAMBLE_EHT_MU,
+                             NanoSeconds(430400)) &&
+             CheckTxDuration(76,
+                             EhtPhy::GetEhtMcs0(),
+                             MHz_u{80},
+                             NanoSeconds(1600),
+                             WIFI_PREAMBLE_EHT_MU,
+                             NanoSeconds(84800)) &&
+             CheckTxDuration(14,
+                             EhtPhy::GetEhtMcs0(),
+                             MHz_u{80},
+                             NanoSeconds(1600),
+                             WIFI_PREAMBLE_EHT_MU,
+                             NanoSeconds(70400)) &&
+             CheckTxDuration(1536,
+                             EhtPhy::GetEhtMcs0(),
+                             MHz_u{160},
+                             NanoSeconds(1600),
+                             WIFI_PREAMBLE_EHT_MU,
+                             NanoSeconds(243200)) &&
+             CheckTxDuration(76,
+                             EhtPhy::GetEhtMcs0(),
+                             MHz_u{160},
+                             NanoSeconds(1600),
+                             WIFI_PREAMBLE_EHT_MU,
+                             NanoSeconds(70400)) &&
+             CheckTxDuration(14,
+                             EhtPhy::GetEhtMcs0(),
+                             MHz_u{160},
+                             NanoSeconds(1600),
+                             WIFI_PREAMBLE_EHT_MU,
+                             NanoSeconds(70400)) &&
+             CheckTxDuration(1536,
+                             EhtPhy::GetEhtMcs0(),
+                             MHz_u{320},
+                             NanoSeconds(1600),
+                             WIFI_PREAMBLE_EHT_MU,
+                             NanoSeconds(164800)) &&
+             CheckTxDuration(76,
+                             EhtPhy::GetEhtMcs0(),
+                             MHz_u{320},
+                             NanoSeconds(1600),
+                             WIFI_PREAMBLE_EHT_MU,
+                             NanoSeconds(78400)) &&
+             CheckTxDuration(14,
+                             EhtPhy::GetEhtMcs0(),
+                             MHz_u{320},
+                             NanoSeconds(1600),
+                             WIFI_PREAMBLE_EHT_MU,
+                             NanoSeconds(78400)) &&
+             CheckTxDuration(1536,
+                             EhtPhy::GetEhtMcs0(),
+                             MHz_u{20},
+                             NanoSeconds(3200),
+                             WIFI_PREAMBLE_EHT_MU,
+                             MicroSeconds(1748)) &&
+             CheckTxDuration(76,
+                             EhtPhy::GetEhtMcs0(),
+                             MHz_u{20},
+                             NanoSeconds(3200),
+                             WIFI_PREAMBLE_EHT_MU,
+                             MicroSeconds(148)) &&
+             CheckTxDuration(14,
+                             EhtPhy::GetEhtMcs0(),
+                             MHz_u{20},
+                             NanoSeconds(3200),
+                             WIFI_PREAMBLE_EHT_MU,
+                             MicroSeconds(84)) &&
+             CheckTxDuration(1536,
+                             EhtPhy::GetEhtMcs0(),
+                             MHz_u{40},
+                             NanoSeconds(3200),
+                             WIFI_PREAMBLE_EHT_MU,
+                             MicroSeconds(900)) &&
+             CheckTxDuration(76,
+                             EhtPhy::GetEhtMcs0(),
+                             MHz_u{40},
+                             NanoSeconds(3200),
+                             WIFI_PREAMBLE_EHT_MU,
+                             MicroSeconds(100)) &&
+             CheckTxDuration(14,
+                             EhtPhy::GetEhtMcs0(),
+                             MHz_u{40},
+                             NanoSeconds(3200),
+                             WIFI_PREAMBLE_EHT_MU,
+                             MicroSeconds(68)) &&
+             CheckTxDuration(1536,
+                             EhtPhy::GetEhtMcs0(),
+                             MHz_u{80},
+                             NanoSeconds(3200),
+                             WIFI_PREAMBLE_EHT_MU,
+                             MicroSeconds(472)) &&
+             CheckTxDuration(76,
+                             EhtPhy::GetEhtMcs0(),
+                             MHz_u{80},
+                             NanoSeconds(3200),
+                             WIFI_PREAMBLE_EHT_MU,
+                             MicroSeconds(88)) &&
+             CheckTxDuration(14,
+                             EhtPhy::GetEhtMcs0(),
+                             MHz_u{80},
+                             NanoSeconds(3200),
+                             WIFI_PREAMBLE_EHT_MU,
+                             MicroSeconds(72)) &&
+             CheckTxDuration(1536,
+                             EhtPhy::GetEhtMcs0(),
+                             MHz_u{160},
+                             NanoSeconds(3200),
+                             WIFI_PREAMBLE_EHT_MU,
+                             MicroSeconds(264)) &&
+             CheckTxDuration(76,
+                             EhtPhy::GetEhtMcs0(),
+                             MHz_u{160},
+                             NanoSeconds(3200),
+                             WIFI_PREAMBLE_EHT_MU,
+                             MicroSeconds(72)) &&
+             CheckTxDuration(14,
+                             EhtPhy::GetEhtMcs0(),
+                             MHz_u{160},
+                             NanoSeconds(3200),
+                             WIFI_PREAMBLE_EHT_MU,
+                             MicroSeconds(72)) &&
+             CheckTxDuration(1536,
+                             EhtPhy::GetEhtMcs0(),
+                             MHz_u{320},
+                             NanoSeconds(3200),
+                             WIFI_PREAMBLE_EHT_MU,
+                             MicroSeconds(176)) &&
+             CheckTxDuration(76,
+                             EhtPhy::GetEhtMcs0(),
+                             MHz_u{320},
+                             NanoSeconds(3200),
+                             WIFI_PREAMBLE_EHT_MU,
+                             MicroSeconds(80)) &&
+             CheckTxDuration(14,
+                             EhtPhy::GetEhtMcs0(),
+                             MHz_u{320},
+                             NanoSeconds(3200),
+                             WIFI_PREAMBLE_EHT_MU,
+                             MicroSeconds(80)) &&
+             CheckTxDuration(1536,
+                             EhtPhy::GetEhtMcs13(),
+                             MHz_u{20},
+                             NanoSeconds(800),
+                             WIFI_PREAMBLE_EHT_MU,
+                             NanoSeconds(129600)) &&
+             CheckTxDuration(76,
+                             EhtPhy::GetEhtMcs13(),
+                             MHz_u{20},
+                             NanoSeconds(800),
+                             WIFI_PREAMBLE_EHT_MU,
+                             NanoSeconds(61600)) &&
+             CheckTxDuration(14,
+                             EhtPhy::GetEhtMcs13(),
+                             MHz_u{20},
+                             NanoSeconds(800),
+                             WIFI_PREAMBLE_EHT_MU,
+                             NanoSeconds(61600)) &&
+             CheckTxDuration(1536,
+                             EhtPhy::GetEhtMcs13(),
+                             MHz_u{40},
+                             NanoSeconds(800),
+                             WIFI_PREAMBLE_EHT_MU,
+                             NanoSeconds(88800)) &&
+             CheckTxDuration(76,
+                             EhtPhy::GetEhtMcs13(),
+                             MHz_u{40},
+                             NanoSeconds(800),
+                             WIFI_PREAMBLE_EHT_MU,
+                             NanoSeconds(61600)) &&
+             CheckTxDuration(14,
+                             EhtPhy::GetEhtMcs13(),
+                             MHz_u{40},
+                             NanoSeconds(800),
+                             WIFI_PREAMBLE_EHT_MU,
+                             NanoSeconds(61600)) &&
+             CheckTxDuration(1536,
+                             EhtPhy::GetEhtMcs13(),
+                             MHz_u{80},
+                             NanoSeconds(800),
+                             WIFI_PREAMBLE_EHT_MU,
+                             NanoSeconds(75200)) &&
+             CheckTxDuration(76,
+                             EhtPhy::GetEhtMcs13(),
+                             MHz_u{80},
+                             NanoSeconds(800),
+                             WIFI_PREAMBLE_EHT_MU,
+                             NanoSeconds(61600)) &&
+             CheckTxDuration(14,
+                             EhtPhy::GetEhtMcs13(),
+                             MHz_u{80},
+                             NanoSeconds(800),
+                             WIFI_PREAMBLE_EHT_MU,
+                             NanoSeconds(61600)) &&
+             CheckTxDuration(1536,
+                             EhtPhy::GetEhtMcs13(),
+                             MHz_u{160},
+                             NanoSeconds(800),
+                             WIFI_PREAMBLE_EHT_MU,
+                             NanoSeconds(61600)) &&
+             CheckTxDuration(76,
+                             EhtPhy::GetEhtMcs13(),
+                             MHz_u{160},
+                             NanoSeconds(800),
+                             WIFI_PREAMBLE_EHT_MU,
+                             NanoSeconds(61600)) &&
+             CheckTxDuration(14,
+                             EhtPhy::GetEhtMcs13(),
+                             MHz_u{160},
+                             NanoSeconds(800),
+                             WIFI_PREAMBLE_EHT_MU,
+                             NanoSeconds(61600)) &&
+             CheckTxDuration(1536,
+                             EhtPhy::GetEhtMcs13(),
+                             MHz_u{320},
+                             NanoSeconds(800),
+                             WIFI_PREAMBLE_EHT_MU,
+                             NanoSeconds(61600)) &&
+             CheckTxDuration(76,
+                             EhtPhy::GetEhtMcs13(),
+                             MHz_u{320},
+                             NanoSeconds(800),
+                             WIFI_PREAMBLE_EHT_MU,
+                             NanoSeconds(61600)) &&
+             CheckTxDuration(14,
+                             EhtPhy::GetEhtMcs13(),
+                             MHz_u{320},
+                             NanoSeconds(800),
+                             WIFI_PREAMBLE_EHT_MU,
+                             NanoSeconds(61600)) &&
+             CheckTxDuration(1536,
+                             EhtPhy::GetEhtMcs13(),
+                             MHz_u{20},
+                             NanoSeconds(1600),
+                             WIFI_PREAMBLE_EHT_MU,
+                             NanoSeconds(134400)) &&
+             CheckTxDuration(76,
+                             EhtPhy::GetEhtMcs13(),
+                             MHz_u{20},
+                             NanoSeconds(1600),
+                             WIFI_PREAMBLE_EHT_MU,
+                             NanoSeconds(62400)) &&
+             CheckTxDuration(14,
+                             EhtPhy::GetEhtMcs13(),
+                             MHz_u{20},
+                             NanoSeconds(1600),
+                             WIFI_PREAMBLE_EHT_MU,
+                             NanoSeconds(62400)) &&
+             CheckTxDuration(1536,
+                             EhtPhy::GetEhtMcs13(),
+                             MHz_u{40},
+                             NanoSeconds(1600),
+                             WIFI_PREAMBLE_EHT_MU,
+                             NanoSeconds(91200)) &&
+             CheckTxDuration(76,
+                             EhtPhy::GetEhtMcs13(),
+                             MHz_u{40},
+                             NanoSeconds(1600),
+                             WIFI_PREAMBLE_EHT_MU,
+                             NanoSeconds(62400)) &&
+             CheckTxDuration(14,
+                             EhtPhy::GetEhtMcs13(),
+                             MHz_u{40},
+                             NanoSeconds(1600),
+                             WIFI_PREAMBLE_EHT_MU,
+                             NanoSeconds(62400)) &&
+             CheckTxDuration(1536,
+                             EhtPhy::GetEhtMcs13(),
+                             MHz_u{80},
+                             NanoSeconds(1600),
+                             WIFI_PREAMBLE_EHT_MU,
+                             NanoSeconds(76800)) &&
+             CheckTxDuration(76,
+                             EhtPhy::GetEhtMcs13(),
+                             MHz_u{80},
+                             NanoSeconds(1600),
+                             WIFI_PREAMBLE_EHT_MU,
+                             NanoSeconds(62400)) &&
+             CheckTxDuration(14,
+                             EhtPhy::GetEhtMcs13(),
+                             MHz_u{80},
+                             NanoSeconds(1600),
+                             WIFI_PREAMBLE_EHT_MU,
+                             NanoSeconds(62400)) &&
+             CheckTxDuration(1536,
+                             EhtPhy::GetEhtMcs13(),
+                             MHz_u{160},
+                             NanoSeconds(1600),
+                             WIFI_PREAMBLE_EHT_MU,
+                             NanoSeconds(62400)) &&
+             CheckTxDuration(76,
+                             EhtPhy::GetEhtMcs13(),
+                             MHz_u{160},
+                             NanoSeconds(1600),
+                             WIFI_PREAMBLE_EHT_MU,
+                             NanoSeconds(62400)) &&
+             CheckTxDuration(14,
+                             EhtPhy::GetEhtMcs13(),
+                             MHz_u{160},
+                             NanoSeconds(1600),
+                             WIFI_PREAMBLE_EHT_MU,
+                             NanoSeconds(62400)) &&
+             CheckTxDuration(1536,
+                             EhtPhy::GetEhtMcs13(),
+                             MHz_u{320},
+                             NanoSeconds(1600),
+                             WIFI_PREAMBLE_EHT_MU,
+                             NanoSeconds(62400)) &&
+             CheckTxDuration(76,
+                             EhtPhy::GetEhtMcs13(),
+                             MHz_u{320},
+                             NanoSeconds(1600),
+                             WIFI_PREAMBLE_EHT_MU,
+                             NanoSeconds(62400)) &&
+             CheckTxDuration(14,
+                             EhtPhy::GetEhtMcs13(),
+                             MHz_u{320},
+                             NanoSeconds(1600),
+                             WIFI_PREAMBLE_EHT_MU,
+                             NanoSeconds(62400)) &&
+             CheckTxDuration(1536,
+                             EhtPhy::GetEhtMcs13(),
+                             MHz_u{20},
+                             NanoSeconds(3200),
+                             WIFI_PREAMBLE_EHT_MU,
+                             MicroSeconds(144)) &&
+             CheckTxDuration(76,
+                             EhtPhy::GetEhtMcs13(),
+                             MHz_u{20},
+                             NanoSeconds(3200),
+                             WIFI_PREAMBLE_EHT_MU,
+                             MicroSeconds(64)) &&
+             CheckTxDuration(14,
+                             EhtPhy::GetEhtMcs13(),
+                             MHz_u{20},
+                             NanoSeconds(3200),
+                             WIFI_PREAMBLE_EHT_MU,
+                             MicroSeconds(64)) &&
+             CheckTxDuration(1536,
+                             EhtPhy::GetEhtMcs13(),
+                             MHz_u{40},
+                             NanoSeconds(3200),
+                             WIFI_PREAMBLE_EHT_MU,
+                             MicroSeconds(96)) &&
+             CheckTxDuration(76,
+                             EhtPhy::GetEhtMcs13(),
+                             MHz_u{40},
+                             NanoSeconds(3200),
+                             WIFI_PREAMBLE_EHT_MU,
+                             MicroSeconds(64)) &&
+             CheckTxDuration(14,
+                             EhtPhy::GetEhtMcs13(),
+                             MHz_u{40},
+                             NanoSeconds(3200),
+                             WIFI_PREAMBLE_EHT_MU,
+                             MicroSeconds(64)) &&
+             CheckTxDuration(1536,
+                             EhtPhy::GetEhtMcs13(),
+                             MHz_u{80},
+                             NanoSeconds(3200),
+                             WIFI_PREAMBLE_EHT_MU,
+                             MicroSeconds(80)) &&
+             CheckTxDuration(76,
+                             EhtPhy::GetEhtMcs13(),
+                             MHz_u{80},
+                             NanoSeconds(3200),
+                             WIFI_PREAMBLE_EHT_MU,
+                             MicroSeconds(64)) &&
+             CheckTxDuration(14,
+                             EhtPhy::GetEhtMcs13(),
+                             MHz_u{80},
+                             NanoSeconds(3200),
+                             WIFI_PREAMBLE_EHT_MU,
+                             MicroSeconds(64)) &&
+             CheckTxDuration(1536,
+                             EhtPhy::GetEhtMcs13(),
+                             MHz_u{160},
+                             NanoSeconds(3200),
+                             WIFI_PREAMBLE_EHT_MU,
+                             MicroSeconds(64)) &&
+             CheckTxDuration(76,
+                             EhtPhy::GetEhtMcs13(),
+                             MHz_u{160},
+                             NanoSeconds(3200),
+                             WIFI_PREAMBLE_EHT_MU,
+                             MicroSeconds(64)) &&
+             CheckTxDuration(14,
+                             EhtPhy::GetEhtMcs13(),
+                             MHz_u{160},
+                             NanoSeconds(3200),
+                             WIFI_PREAMBLE_EHT_MU,
+                             MicroSeconds(64)) &&
+             CheckTxDuration(1536,
+                             EhtPhy::GetEhtMcs13(),
+                             MHz_u{320},
+                             NanoSeconds(3200),
+                             WIFI_PREAMBLE_EHT_MU,
+                             MicroSeconds(64)) &&
+             CheckTxDuration(76,
+                             EhtPhy::GetEhtMcs13(),
+                             MHz_u{320},
+                             NanoSeconds(3200),
+                             WIFI_PREAMBLE_EHT_MU,
+                             MicroSeconds(64)) &&
+             CheckTxDuration(14,
+                             EhtPhy::GetEhtMcs13(),
+                             MHz_u{320},
+                             NanoSeconds(3200),
+                             WIFI_PREAMBLE_EHT_MU,
+                             MicroSeconds(64));
+
+    NS_TEST_EXPECT_MSG_EQ(retval, true, "an 802.11be SU duration failed");
+
+    // 802.11be MU durations
+    retval =
+        retval &&
+        CheckMuTxDuration(
+            std::list<uint32_t>{1536, 1536},
+            std::list<HeMuUserInfo>{{EhtRu::RuSpec{RuType::RU_242_TONE, 1, true, true}, 0, 1},
+                                    {EhtRu::RuSpec{RuType::RU_242_TONE, 2, true, true}, 0, 1}},
+            MHz_u{40},
+            NanoSeconds(800),
+            WIFI_PREAMBLE_EHT_MU,
+            NanoSeconds(1493600)) // equivalent to 802.11ax MU
+        && CheckMuTxDuration(
+               std::list<uint32_t>{1536, 1536},
+               std::list<HeMuUserInfo>{{EhtRu::RuSpec{RuType::RU_242_TONE, 1, true, true}, 1, 1},
+                                       {EhtRu::RuSpec{RuType::RU_242_TONE, 2, true, true}, 0, 1}},
+               MHz_u{40},
+               NanoSeconds(800),
+               WIFI_PREAMBLE_EHT_MU,
+               NanoSeconds(1493600)) // shouldn't change if first PSDU is shorter
+        && CheckMuTxDuration(
+               std::list<uint32_t>{1536, 76},
+               std::list<HeMuUserInfo>{{EhtRu::RuSpec{RuType::RU_242_TONE, 1, true, true}, 0, 1},
+                                       {EhtRu::RuSpec{RuType::RU_242_TONE, 2, true, true}, 0, 1}},
+               MHz_u{40},
+               NanoSeconds(800),
+               WIFI_PREAMBLE_EHT_MU,
+               NanoSeconds(1493600));
 
     NS_TEST_EXPECT_MSG_EQ(retval, true, "an 802.11be MU duration failed");
 
@@ -1437,9 +2016,9 @@
  * @ingroup wifi-test
  * @ingroup tests
  *
- * @brief HE-SIG-B duration test
+ * @brief HE-SIG-B/EHT-SIG duration test
  */
-class HeSigBDurationTest : public TestCase
+class MuSigDurationTest : public TestCase
 {
   public:
     /**
